//
//  OffcnIMSocketManager.h
//  OffcnIMSDKiOS
//
//  Created by vockey on 2020/8/24.
//  Copyright © 2020 offcn. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSUInteger, OffcnIMConnectStatus) {
    OffcnIMConnectStatusSuccess,    //连接成功
    OffcnIMConnectStatusFail,           //连接失败
    OffcnIMConnectStatusBreak,          //连接断开
    OffcnIMConnectStatusDisConnectOK,   //手动断开成功
};

//收到消息回调
typedef void(^OffcnIMConnectReceiveMessage)(NSString *message);

//连接状态回调
typedef void(^OffcnIMReceiveConnectStatus)(OffcnIMConnectStatus status,NSString *errorMessage);

@interface OffcnIMSocketManager : NSObject

@property (nonatomic, copy) OffcnIMConnectReceiveMessage connectReceiveMessage;
@property (nonatomic, copy) OffcnIMReceiveConnectStatus connectStatus;


+(OffcnIMSocketManager *)defaultService;

//建立连接
-(void)connectIMServerWithParam:(NSString *)param;
//断开连接
-(void)disConnectIMServer;
@end

NS_ASSUME_NONNULL_END
